;****** Startup-File fr ST STM32F302xBx  ******
;
; Speicherbereiche
; Flash:                0 .. 0001_FFFFh    (  128 K )
; SRAM1:        2000_0000 .. 2000_7FFFh    (   32 K )
;
; maximaler CPU Takt: 72 MHz


     EXPORT     Errors
     EXPORT     ErrAddr
     EXPORT     Manifest
     EXPORT     Kaltstart
     EXPORT     Ticks
     EXPORT     StartOfRam
     EXPORT     EndOfRam


;--------------------------------------------------------------------
; hier die allerntigsten Speicherbereiche
Top_Ram         EQU     0x20008000      ; der interne RAM geht von 20000000 bis 10007FFFh
Errors          EQU     Top_Ram - 4     ; Bitfeld zum Merken von Fehlern etc. und zugleich..
ErrAddr         EQU     Errors  - 4
Ticks           EQU     ErrAddr - 4
__initial_sp    EQU     Ticks   - 4

StartOfRam      EQU     0x20000000
EndOfRam        EQU     __initial_sp - 1024

;********************************************************************

;                PRESERVE8
;                THUMB

;********************* Vektortafel und Kaltstart ***********************
; Vector Table Mapped to Address 0 at Reset
                AREA    RESET, CODE, READONLY
                PRESERVE8
                THUMB


                EXPORT  __Vectors
;                                                   Addr Vect Int Typ
__Vectors       DCD     __initial_sp              ; 0      0   -  Top of Stack
                DCD     Kaltstart                 ; 4      1   -  Reset Handler
                DCD     NMI_Handler               ; 8      2   -  Non Maskable Interrupt
                DCD     HardFault_Handler         ; C      3   -  Cortex-M4 SV Hard Fault Interrupt
                DCD     MemoryManagement_Handler  ; 10     4   -  Cortex-M4 Memory Management Interrupt
                DCD     BusFault_Handler          ; 14     5   -  Cortex-M4 Bus Fault Interrupt
                DCD     UsageFault_Handler        ; 18     6   -  Cortex-M4 Usage Fault Interrupt
                DCD     Reserved                  ; 1C     7   -
                DCD     Reserved                  ; 20     8   -
                DCD     Reserved                  ; 24     9   -
                DCD     Reserved                  ; 28    10   -
                DCD     SVC_Handler               ; 2C    11   -  Cortex-M4 SV Call Interrupt
		DCD     Reserved                  ; 30    12   -  war Debug Monitor
		DCD     Reserved                  ; 34    13   -
                DCD     PendSV_Handler            ; 38    14   -  Cortex-M4 pendable request Interrupt
                DCD     SysTick_Handler           ; 3C    15   -  Cortex-M0 System Tick Interrupt

                ; STM32F302 specific external Interrupts      Int
                DCD     WWDG_Handler              ; 40    16   0  Window Watchdog
                DCD     PVD_Handler               ; 44    17   1  PVD through EXTI Line 16 detect
                DCD     Tamper_Handler            ; 48    18   2  Tamper+TimeStamp through EXTI Line 19
                DCD     RTC_Handler               ; 4C    19   3  RTC Wakeup through EXTI Line 20
                DCD     FLASH_Handler             ; 50    20   4  Flash global Int
                DCD     RCC_Handler               ; 54    21   5  RCC global Int
                DCD     EXTI0_Handler             ; 58    22   6  EXTI Line 0
                DCD     EXTI1_Handler             ; 5C    23   7  EXTI Line 1
                DCD     EXTI2TS_Handler           ; 60    24   8  EXTI Line 2 + TouchSense
                DCD     EXTI3_Handler             ; 64    25   9  EXTI Line 3
                DCD     EXTI4_Handler             ; 68    26  10  EXTI Line 4
                DCD     DMA1_Channel1_Handler     ; 6C    27  11  DMA1 Kanal 1
                DCD     DMA1_Channel2_Handler     ; 70    28  12  DMA1 Kanal 2
                DCD     DMA1_Channel3_Handler     ; 74    29  13  DMA1 Kanal 3
                DCD     DMA1_Channel4_Handler     ; 78    30  14  DMA1 Kanal 4
                DCD     DMA1_Channel5_Handler     ; 7C    31  15  DMA1 Kanal 5
                DCD     DMA1_Channel6_Handler     ; 80    32  16  DMA1 Kanal 6
                DCD     DMA1_Channel7_Handler     ; 84    33  17  DMA1 Kanal 7
                DCD     ADC1_2__Handler           ; 88    34  18  ADC1 + ADC2 global Int
                DCD     USB_HP_CANTX_Handler      ; 8C    35  19  USB hi Prio + CAN Tx
                DCD     USB_LP_CANRX_Handler      ; 90    36  20  USB lo Prio + CAN Rx
                DCD     CAN_RX1_Handler           ; 94    37  21  CAN Rx 1
                DCD     CAN_SCE_Handler           ; 98    38  22  CAN Sce
                DCD     EXTI9_5_Handler           ; 9C    39  23  EXTI Line 9:5
                DCD     TIM1_BRK_TIM15_Handler    ; A0    40  24  Timer 1 und Timer 15
                DCD     TIM1_UP_TIM16_Handler     ; A4    41  25  Timer 1 und Timer 16
                DCD     TIM1_TRGCOM_TIM17_Handler ; A8    42  26  Timer 1 und Timer 17
		DCD     TIM1_CC_Handler           ; AC    43  27  Timer 1 Cap/Comp
		DCD     TIM2_Handler              ; B0    44  28  Timer 2 global
		DCD     TIM3_Handler              ; B4    45  29  Timer 3 global
		DCD     TIM4_Handler              ; B8    46  30  Timer 4 global
		DCD     I2C1_EV_Handler           ; BC    47  31  I2C1 Event
		DCD     I2C1_ER_Handler           ; C0    48  32  I2C1 Error
		DCD     I2C2_EV_Handler           ; C4    49  33  I2C2 Event
		DCD     I2C2_ER_Handler           ; C8    50  34  I2C2 Error
		DCD     SPI1_Handler              ; CC    51  35
		DCD     SPI2_Handler              ; D0    52  36
		DCD     USART1_IRQHandler         ; D4    53  37  USART 1 glob + EXTI 25
		DCD     USART2_IRQHandler         ; D8    54  38  USART 2 glob + EXTI 26
		DCD     USART3_IRQHandler         ; DC    55  39  USART 3 glob + EXTI 28
		DCD     EXTI15_10_Handler         ; E0    56  40  EXTI Line 15:10
		DCD     RTC_Alarm_Handler         ; E4    57  41  RTC
		DCD     USB_Wakeup_Handler        ; E8    58  42  USB Wakeup from Suspend + EXTI 18
		DCD     Reserved                  ; EC    59  43
		DCD     Reserved                  ; F0    60  44
		DCD     Reserved                  ; F4    61  45
		DCD     Reserved                  ; F8    62  46
		DCD     Reserved                  ; FC    63  47
		DCD     FMC_Handler               ; 100   64  48  FMC global
		DCD     Reserved                  ; 104   65  49
		DCD     Reserved                  ; 108   66  50
		DCD     SPI3_Handler              ; 10C   67  51  SPI 3 global
		DCD     UART4_IRQHandler          ; 110   68  52  UART 4 global
		DCD     UART5_IRQHandler          ; 114   69  53  UART 5 global
		DCD     TIM6_DAC_Handler          ; 118   70  54  TIM6 glob + DAC1 Underrun
		DCD     Reserved                  ; 11C   71  55
                DCD     DMA2_Channel1_Handler     ; 120   72  56  DMA2 Kanal 1
                DCD     DMA2_Channel2_Handler     ; 124   73  57  DMA2 Kanal 2
                DCD     DMA2_Channel3_Handler     ; 128   74  58  DMA2 Kanal 3
                DCD     DMA2_Channel4_Handler     ; 12C   75  59  DMA2 Kanal 4
                DCD     DMA2_Channel5_Handler     ; 130   76  60  DMA2 Kanal 5
		DCD     Reserved                  ; 134   77  61
		DCD     Reserved                  ; 138   78  62
		DCD     Reserved                  ; 13C   79  63
                DCD     COMP1_2_Handler           ; 140   80  64  Comp1 + Comp2 + EXTI 21+22
		DCD     COMP4_6_Handler           ; 144   81  65  Comp4 + Comp6 + EXTI 30+32
		DCD     Reserved                  ; 148   82  66
		DCD     Reserved                  ; 14C   83  67
		DCD     Reserved                  ; 150   84  68
		DCD     Reserved                  ; 154   85  69
		DCD     Reserved                  ; 158   86  70
		DCD     Reserved                  ; 15C   87  71
		DCD     I2C3_EV_Handler           ; 160   88  72  I2C3 Event
		DCD     I2C3_ER_Handler           ; 164   89  73  I2C3 Error
		DCD     USB_HP_Handler            ; 168   90  74  USB hi Prio
		DCD     USB_LP_Handler            ; 16C   91  75  USB lo Prio
		DCD     USB_WakeUp_RMP_Handler    ; 170   92  76  USB Wakeup from Suspend + EXTI 18
                DCD     FPU_Handler               ; 174   93  77  Floating Point Errors
		DCD     SPI4_Handler              ; 178   94  78  SPI4 global

;
Manifest        DCB    "STM32F302xBx (Cortex M4F)",0
                ALIGN


; Kaltstart: CPU hat SP bereits von Adresse 0 geladen
; wir exportieren __main, um dem Laden eines ganzen Rattenschwanzes
; von unbenutzten Bibliotheksfunktionen vorzubeugen.

Kaltstart       PROC
                IMPORT  main
                IMPORT  sysconfig
                EXPORT  __main

__main          LDR     R0, =Errors
                LDR     R1, =0
                STR     R1, [R0]               ;  Fehlerbits lschen
                B       MerkeFehler


Warmstart
                LDR     R1, =1
                B       MerkeFehler


Restart
                NOP

MerkeFehler
                LDR     R0, =Errors
                LDR     R2,[R0]
                ORRS    R2,R1
                STR     R2,[R0]

                ; FPU einschalten
                LDR.W   R0, =0xE000ED88     ; CPACR is located at address 0xE000ED88
                LDR     R1, [R0]            ; Read CPACR
                ORR     R1, R1, #(0xF<<20)  ; Set bits 20-23 to enable CP10 and CP11 coprocessors
                STR     R1, [R0]            ; Write back the modified value to the CPACR

                LDR     R0, =sysconfig
                BLX     R0

                CPSIE   i
                LDR     R0, =main
                BLX     R0
                B       Warmstart
                ENDP


;-------------- Exception Handlers --------------------------------------

NMI_Handler     PROC
                EXPORT  NMI_Handler       [WEAK]
                LDR     R1, =1024             ; war NMI
                B       Restart
                ENDP

HardFault_Handler  PROC
                EXPORT  HardFault_Handler [WEAK]
                LDR    R0, [R13, #24]        ; Get previous PC
                LDRH   R1, [R0]              ; Get instruction
                LDR    R2, =0xBEAB           ; The special BKPT instruction
                CMP    R1, R2                ; Test if the instruction at previous PC is BKPT
                BNE    HardFault_Restart     ; Not BKPT

                ADDS   R0, #4                ; Skip BKPT and next line
                STR    R0, [R13, #24]        ; Save previous PC
                BX     LR

HardFault_Restart
                LDR     R1, =4               ; war Hardfault
                B       Restart
                ENDP


MemoryManagement_Handler PROC
                EXPORT  MemoryManagement_Handler  [WEAK]
                LDR     R1, =8               ; war MM
                B       Restart
                ENDP



BusFault_Handler  PROC
                EXPORT  BusFault_Handler  [WEAK]
                LDR     R1, =16               ; war Zugriff
                B       Restart
                ENDP


UsageFault_Handler PROC
                EXPORT  UsageFault_Handler       [WEAK]
                LDR     R1, =32               ; war Zugriff
                B       Restart
                ENDP



SVC_Handler     PROC
                EXPORT  SVC_Handler       [WEAK]
                LDR     R1, =64               ; war SVC
                B       Restart
                ENDP


DebugMonitor_Handler PROC
                EXPORT  DebugMonitor_Handler  [WEAK]
                LDR     R1, =128               ; war SVC, ist hier reserviert
                B       Restart
                ENDP



PendSV_Handler  PROC
                EXPORT  PendSV_Handler    [WEAK]
                LDR     R1, =256              ; war PendSVC
                B       Restart
                ENDP

SysTick_Handler PROC
                EXPORT  SysTick_Handler   [WEAK]
                LDR     R1, =512              ; war SysTick
                B       Restart
                ENDP


Reserved PROC
                ; STM32F302xBx specific external Interrupts
                EXPORT     WWDG_Handler              [WEAK]
                EXPORT     PVD_Handler               [WEAK]
                EXPORT     Tamper_Handler            [WEAK]
                EXPORT     RTC_Handler               [WEAK]
                EXPORT     FLASH_Handler             [WEAK]
                EXPORT     RCC_Handler               [WEAK]
                EXPORT     EXTI0_Handler             [WEAK]
                EXPORT     EXTI1_Handler             [WEAK]
                EXPORT     EXTI2TS_Handler           [WEAK]
                EXPORT     EXTI3_Handler             [WEAK]
                EXPORT     EXTI4_Handler             [WEAK]
                EXPORT     DMA1_Channel1_Handler     [WEAK]
                EXPORT     DMA1_Channel2_Handler     [WEAK]
                EXPORT     DMA1_Channel3_Handler     [WEAK]
                EXPORT     DMA1_Channel4_Handler     [WEAK]
                EXPORT     DMA1_Channel5_Handler     [WEAK]
                EXPORT     DMA1_Channel6_Handler     [WEAK]
                EXPORT     DMA1_Channel7_Handler     [WEAK]
                EXPORT     ADC1_2__Handler           [WEAK]
                EXPORT     USB_HP_CANTX_Handler      [WEAK]
                EXPORT     USB_LP_CANRX_Handler      [WEAK]
                EXPORT     CAN_RX1_Handler           [WEAK]
                EXPORT     CAN_SCE_Handler           [WEAK]
                EXPORT     EXTI9_5_Handler           [WEAK]
                EXPORT     TIM1_BRK_TIM15_Handler    [WEAK]
                EXPORT     TIM1_UP_TIM16_Handler     [WEAK]
                EXPORT     TIM1_TRGCOM_TIM17_Handler [WEAK]
		EXPORT     TIM1_CC_Handler           [WEAK]
		EXPORT     TIM2_Handler              [WEAK]
		EXPORT     TIM3_Handler              [WEAK]
		EXPORT     TIM4_Handler              [WEAK]
		EXPORT     I2C1_EV_Handler           [WEAK]
		EXPORT     I2C1_ER_Handler           [WEAK]
		EXPORT     I2C2_EV_Handler           [WEAK]
		EXPORT     I2C2_ER_Handler           [WEAK]
		EXPORT     SPI1_Handler              [WEAK]
		EXPORT     SPI2_Handler              [WEAK]
		EXPORT     USART1_IRQHandler         [WEAK]
		EXPORT     USART2_IRQHandler         [WEAK]
		EXPORT     USART3_IRQHandler         [WEAK]
		EXPORT     EXTI15_10_Handler         [WEAK]
		EXPORT     RTC_Alarm_Handler         [WEAK]
		EXPORT     USB_Wakeup_Handler        [WEAK]
		EXPORT     FMC_Handler               [WEAK]
		EXPORT     SPI3_Handler              [WEAK]
		EXPORT     UART4_IRQHandler          [WEAK]
		EXPORT     UART5_IRQHandler          [WEAK]
		EXPORT     TIM6_DAC_Handler          [WEAK]
                EXPORT     DMA2_Channel1_Handler     [WEAK]
                EXPORT     DMA2_Channel2_Handler     [WEAK]
                EXPORT     DMA2_Channel3_Handler     [WEAK]
                EXPORT     DMA2_Channel4_Handler     [WEAK]
                EXPORT     DMA2_Channel5_Handler     [WEAK]
                EXPORT     COMP1_2_Handler           [WEAK]
		EXPORT     COMP4_6_Handler           [WEAK]
		EXPORT     I2C3_EV_Handler           [WEAK]
		EXPORT     I2C3_ER_Handler           [WEAK]
		EXPORT     USB_HP_Handler            [WEAK]
		EXPORT     USB_LP_Handler            [WEAK]
		EXPORT     USB_WakeUp_RMP_Handler    [WEAK]
                EXPORT     FPU_Handler               [WEAK]
		EXPORT     SPI4_Handler              [WEAK]


                LDR     R1, =2      ; RAISE, war reserved
                B       Restart


WWDG_Handler
PVD_Handler
Tamper_Handler
RTC_Handler
FLASH_Handler
RCC_Handler
EXTI0_Handler
EXTI1_Handler
EXTI2TS_Handler
EXTI3_Handler
EXTI4_Handler
DMA1_Channel1_Handler
DMA1_Channel2_Handler
DMA1_Channel3_Handler
DMA1_Channel4_Handler
DMA1_Channel5_Handler
DMA1_Channel6_Handler
DMA1_Channel7_Handler
ADC1_2__Handler
USB_HP_CANTX_Handler
USB_LP_CANRX_Handler
CAN_RX1_Handler
CAN_SCE_Handler
EXTI9_5_Handler
TIM1_BRK_TIM15_Handler
TIM1_UP_TIM16_Handler
TIM1_TRGCOM_TIM17_Handler
TIM1_CC_Handler
TIM2_Handler
TIM3_Handler
TIM4_Handler
I2C1_EV_Handler
I2C1_ER_Handler
I2C2_EV_Handler
I2C2_ER_Handler
SPI1_Handler
SPI2_Handler
USART1_IRQHandler
USART2_IRQHandler
USART3_IRQHandler
EXTI15_10_Handler
RTC_Alarm_Handler
USB_Wakeup_Handler
FMC_Handler
SPI3_Handler
UART4_IRQHandler
UART5_IRQHandler
TIM6_DAC_Handler
DMA2_Channel1_Handler
DMA2_Channel2_Handler
DMA2_Channel3_Handler
DMA2_Channel4_Handler
DMA2_Channel5_Handler
COMP1_2_Handler
COMP4_6_Handler
I2C3_EV_Handler
I2C3_ER_Handler
USB_HP_Handler
USB_LP_Handler
USB_WakeUp_RMP_Handler
FPU_Handler
SPI4_Handler

                LDR     R1, =2048                ; war WEAK Int
                B       Restart
                ENDP


                ALIGN
                LTORG

                END

